#include "ofApp.h"

//--------------------------------------------------------------
void ofApp::setup(){
    
    nTips=0;
    isThereDrawnAlready = false;
    drawingMoved = false;
    ofEnableSmoothing();
    ofSetCircleResolution(100);
    colorR=0;
    colorG=0;
    colorB=0;
    Radius = 100;
    centerX = ofGetWidth()/2;
    centerY = ofGetHeight()/2;
}

//--------------------------------------------------------------
void ofApp::update(){
}

//--------------------------------------------------------------
void ofApp::draw(){
	ofFill();
    if(nTips>2){
    //SHAPE
        ofBeginShape();
        ofSetColor(colorR,colorG,colorB);
        ofCurveVertex(myPoints[nTips-1]);
        for (int i = 0; i < nTips; i++){
            ofCurveVertex(myPoints[i]);
        }
        ofCurveVertex(myPoints[0]);
        ofCurveVertex(myPoints[1]);
        ofEndShape();
    }
    if(isThereDrawnAlready == true){
    //RECORDER
        ofSetColor(255, 25);
        ofDrawCircle(centerX,centerY,145);
        ofSetColor(colorR,colorG,colorB);
        ofDrawCircle(centerX,centerY,135);
        for (int i = 0; i < nTips; i++){
            ofSetColor(0,25);
            ofDrawCircle(myPoints[i], Radius);
        }
    }
    
    if(drawingMoved == true){
    //CHANGED SHAPE
        ofBeginShape();
        ofSetColor(colorR,colorG,colorB);
        ofCurveVertex(myPoints[nTips-1]);
        for (int i = 0; i < nTips; i++){
            ofCurveVertex(myPoints[i]);
        }
        ofCurveVertex(myPoints[0]);
        ofCurveVertex(myPoints[1]);
        ofEndShape();
    }
    //ADD pulse + CHANGE pulse -> tapping the innercircle and the counts of this
    //ADD directional arrows for other people using compass + send mechanic by dragging the figure to the arrow
    //ADD see a response when tapping an arrow
}

//--------------------------------------------------------------
void ofApp::exit(){
}

//--------------------------------------------------------------
void ofApp::touchDown(ofTouchEventArgs & touch){
    if(isThereDrawnAlready == true){
        if(touch.id==0){
            if(ofDist(centerX,centerY,touch.x,touch.y)<75){
                selected ++;                                                //make a counter for the ammount of touches = pulse
            }
        }
    }
}

//--------------------------------------------------------------
void ofApp::touchMoved(ofTouchEventArgs & touch){
	//CREATE figure points
    if(isThereDrawnAlready == false){
        if(touch.id == 0 ){
                colorR=ofMap(touch.x+50,ofGetWidth(),0,225,100);
                colorG=0;
                colorB=225-(touch.x/5);
        }
        
        nTips=round(ofMap(touch.y,ofGetHeight(),0,3,9));
        float angleChangePerPt = TWO_PI / (float)nTips;
        float Radius = 500;
        float origx = centerX;
        float origy = centerY;
        float angle = 0;
        myPoints.clear();
        for (int i = 0; i < nTips; i++){
            float x = origx + Radius * cos(angle);
            float y = origy + Radius * sin(angle);
            ofPoint newPoint(x,y);
            myPoints.push_back(newPoint);
            angle += angleChangePerPt;
        }
    }
    //MOVE edit options
    if(isThereDrawnAlready == true){
        //MOVE points
        for (int i = 0; i < nTips; i++){
        if(ofDist(myPoints[i].x,myPoints[i].y,touch.x,touch.y)<Radius && drawingMoved == false){
            myPoints[i].x= touch.x;
            myPoints[i].y= touch.y;
            }
        }
        //MOVE the whole figure
        if(ofDist(centerX,centerY,touch.x,touch.y)<75){
            //selected ++;
            for (int i = 0; i < nTips; i++){
                myPoints[i].x = myPoints[i].x + (touch.x - centerX);
                myPoints[i].y = myPoints[i].y + (touch.y - centerY);
            drawingMoved = true;
            }
            centerX=touch.x;
            centerY=touch.y;
        }
        //if(centerX == 0 || centerX == ofGetWidth() || centerY == 0 || centerY == ofGetHeight()){
        //have drawing move in the same direction as before
        //}
    }
}

//--------------------------------------------------------------
void ofApp::touchUp(ofTouchEventArgs & touch){
    isThereDrawnAlready = true;
    drawingMoved = false;
}

//--------------------------------------------------------------
void ofApp::touchDoubleTap(ofTouchEventArgs & touch){
    isThereDrawnAlready = false;
}

//--------------------------------------------------------------
void ofApp::touchCancelled(ofTouchEventArgs & touch){
}

//--------------------------------------------------------------
void ofApp::lostFocus(){
}

//--------------------------------------------------------------
void ofApp::gotFocus(){
}

//--------------------------------------------------------------
void ofApp::gotMemoryWarning(){
}

//--------------------------------------------------------------
void ofApp::deviceOrientationChanged(int newOrientation){
}
